/*********************************************************************************************************
**				                               Small RTOS 51
**                                   The Real-Time Kernel For Keil c51
**
**                                  (c) Copyright 2002-2002, chenmingji
**                                           All Rights Reserved
**
**                                                  V1.10
**
**
**--------------ǰ汾Ϣ----------------------------------------------------------------------------
*** ļ: OS_CPU.h
** : 
** ա: 200291
** 衡: Small RTOS 51CPU(8051ϵ)صCͷļ,һЩCPUصĺꡣ
**         °汾ҪӦӺ޸һЩ塣
**--------------ʷ汾Ϣ----------------------------------------------------------------------------
** : 
** 汾  V1.00
** ա: 2002620
** 衡: Small RTOS 51CPU(8051ϵ)صCͷļ,һЩCPUصĺꡣ
**
**------------------------------------------------------------------------------------------------------
** ޸:
** ա:
** 衡:
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#define EN_SP2        0                                         /* ֹ(0)(1)ж               */

#ifdef __C51__

typedef unsigned char  uint8;                                   /* ֲ޷8λؼ            */
typedef signed   char  int8;                                    /* ֲз8λؼ            */
typedef unsigned int   uint16;                                  /* ֲ޷16λؼ           */
typedef signed   int   int16;                                   /* ֲз16λؼ           */
typedef unsigned long  uint32;                                  /* ֲ޷32λؼ           */
typedef signed   long  int32;                                   /* ֲз32λؼ           */

#ifndef NULL
#define NULL 0
#endif


#if EN_OS_INT_ENTER >0 
#define  OS_INT_ENTER() OSIntNesting++,EA=1
#endif

#define  OS_ENTER_CRITICAL()  EA = 0,Os_Enter_Sum++             /* ֹж                                     */
#define  OS_EXIT_CRITICAL()   if (--Os_Enter_Sum==0) EA = 1     /* ж                                     */

#define  HIGH_BYTE  0                                           /* uint16ĸλֽ                              */
#define  LOW_BYTE   1                                           /* uint16ĵλֽ                              */

#define  OS_TASK_SW()         OSCtxSw()                         /* л                                  */


#define  IDATA_RAM_SIZE  0x100                                  /* idataС                                    */

extern void OSCtxSw(void);
extern void OSIntCtxSw(void);
#ifndef IN_OS_CPU_C
extern void OSStart(void);
#endif

#define  Sp2Space       4                                       /* ߼жϣжϣջС EN_SP2Ϊ0ʱЧ*/

#define OS_TIME_ISR     1                                       /* ϵͳʱʹõж                                       */

#endif



#ifndef __C51__

SET_EA   MACRO                                                  ;ж
             SETB     EA
         ENDM
         
#endif
