/*********************************************************************************************************
**				                               Small RTOS(51)
**                                   The Real-Time Kernel(For Keil c51)
**
**                                  (c) Copyright 2002-2002, chenmingji
**                                           All Rights Reserved
**
**                                                  V1.10
**
**
**--------------ǰ汾Ϣ----------------------------------------------------------------------------
** ļ: OS_Q.H
** : 
** ա: 2002620
** 衡: Small RTOS(51)ϢͷļһЩһЩ
**
**--------------ʷ汾Ϣ----------------------------------------------------------------------------
** 
**------------------------------------------------------------------------------------------------------
** ޸:
** ա:
** 衡:
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/


#ifndef NOT_OK
#define NOT_OK      255                                 /*                                      */
#endif

#define OS_Q_FULL   8                                   /*                                        */
#define OS_Q_NOT_OK 4                                   /* Ϣ                                       */
#define OS_Q_TMO    2                                   /* ʱ                                       */
#define OS_Q_OK     1                                   /* ɹ                                     */

#ifndef IN_OS_Q
extern uint8 OSQCreate(uint8 OS_Q_MEM_SEL *Buf, uint8 SizeOfBuf);
extern uint8 OSQPend(uint8 data *Ret, uint8 OS_Q_MEM_SEL *Buf, uint8 Tick);
extern uint8 OSQAccept(uint8 data *Ret, uint8 OS_Q_MEM_SEL *Buf);
extern uint8 OSQPost(uint8 OS_Q_MEM_SEL *Buf, uint8 Data);
extern uint8 OSQPostFront(uint8 OS_Q_MEM_SEL *Buf, uint8 Data);
extern uint8 OSQIntPost(uint8 OS_Q_MEM_SEL *Buf, uint8 Data);
extern uint8 OSQIntPostFront(uint8 OS_Q_MEM_SEL *Buf, uint8 Data);
extern uint8 OSQNMsgs(uint8 OS_Q_MEM_SEL *Buf);
extern uint8 OSQSize(uint8 OS_Q_MEM_SEL *Buf);

#endif
