/*********************************************************************************************************
**				                               Small RTOS 51
**                                   The Real-Time Kernel For Keil c51
**
**                                  (c) Copyright 2002-2002, chenmingji
**                                           All Rights Reserved
**
**                                                  V1.00.5
**
**
**--------------ǰ汾Ϣ----------------------------------------------------------------------------
** ļ: OS_CPU_C.C
** : 
** ա: 2002105
** 衡: ͳһһ¸ʽͺ궨
**
**--------------ʷ汾Ϣ----------------------------------------------------------------------------
** ļ: OS_CPU_C.C
** : 
** ա: 2002620
** 衡: Small RTOS 51CPU(8051ϵ)صCԴ
**
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021023
** 衡: ޸OSTickISR()ʹ£ÿνж϶UserTickTimer()
**
**------------------------------------------------------------------------------------------------------
** ޸:
** ա:
** 衡:
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

#define  IN_OS_CPU_C
#include "CONFIG.h"

extern idata uint8 STACK[1];                    /* ջʼλ,OS_CPU_A */
uint8 idata * OSTsakStackBotton[OS_MAX_TASKS + 1];/* ջײλ            */

#if EN_SP2 > 0
uint8 idata  Sp2[Sp2Space];                     /* ߼ж϶ջ           */
#endif

extern void LoadCtx(void);

#if OS_MAX_TASKS < 9            
uint8 data OSFastSwap = 0xff;
#else
uint16 data OSFastSwap = 0xffff;
#endif


/*********************************************************************************************************
** : C_OSCtxSw
** : CдĶջ,Ѿûд,˺ֲǱ
** 䡡: 
** 䡡 : 
** ȫֱ: OSTaskID,OSTsakStackBotton,SP
** ģ: LoadCtx
** 
** : 
** ա: 2002222
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
/*        void C_OSCtxSw(void) 

{
    uint8 idata *cp1,idata *cp2;
    uint8 i,temp;
    
    cp1 = (uint8 idata *)SP +1;
    temp = (uint8 )OSTsakStackBotton[OSNextTaskID+1];
    cp2 = OSTsakStackBotton[OSTaskID+1];
    if( OSNextTaskID > OSTaskID)
    {
        while(cp2 != (uint8 idata *)temp)
        {
            *cp1++ = *cp2++;
        }
        OSNextTaskID++;
        OSTaskID++;
        temp = OSTsakStackBotton[OSTaskID] - (uint8 idata *)SP-1;
        SP = (uint8 )cp1 - 1;        
        for(i = OSTaskID;i < OSNextTaskID; i++)
        {
            OSTsakStackBotton[i] -= temp;
        }
        OSNextTaskID--;
        OSTaskID = OSNextTaskID;
        LoadCtx();    
    }

    if( OSNextTaskID < OSTaskID)
    {
        cp2--;
        cp1--;
        while(cp2 != (uint8 idata *)temp)
        {
            *cp2-- = *cp1--;
        }
        OSTaskID++;
        temp = OSTsakStackBotton[OSTaskID] - (uint8 idata *)SP-1;
        SP = (uint8 )OSTsakStackBotton[OSNextTaskID+1];
        for(i = OSNextTaskID+1;i < OSTaskID; i++)
        {
            OSTsakStackBotton[i] += temp;
        }
        OSTaskID = OSNextTaskID;        
        SP--;
    }
    LoadCtx();
    LoadCtx();
}
*/

/*********************************************************************************************************
** : OSStart
** : Small RTOS 51ʼ,ô˺ʼ,ִIDΪ0
** 䡡: 
** 䡡 : 
** ȫֱ: OSTsakStackBotton,SP
** ģ: LoadCtx
** 
** : 
** ա: 2002222
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void OSStart(void)
        
{
    uint8 idata *cp;
    uint8 i;
    
    cp = STACK;
    
    OSTsakStackBotton[0] = STACK;
    OSTsakStackBotton[OS_MAX_TASKS] = (uint8 idata *)(IDATA_RAM_SIZE % 256);

    *cp++ = ((uint16)(TaskFuction[0])) % 256;
    SP = (uint8) cp;
    *cp++ = ((uint16)(TaskFuction[0])) / 256;

    cp = (uint8 idata *)(IDATA_RAM_SIZE - 1) ;
    for(i = OS_MAX_TASKS - 1; i > 0; i--)
    {
        *cp-- =  ((uint16)(TaskFuction[i])) / 256;
        OSTsakStackBotton[i] = cp;
        *cp-- =  ((uint16)(TaskFuction[i])) % 256;
    }
//    OS_EXIT_CRITICAL();
    LoadCtx();
}

/*********************************************************************************************************
** : OSTickISR
** : ϵͳʱжϷ
** 䡡: 
** 䡡 : 
** ȫֱ: 
** ģ: OS_IBT_ENTER,(UserTickTimer),OSTimeTick,OSIntExit
** 
** : 
** ա: 2002222
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021023
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_INT_ENTER >0 
#pragma disable                                        /* ȼжϣ򣬱һ                 */
#endif
        void OSTickISR(void) interrupt OS_TIME_ISR

{
#if TICK_TIMER_SHARING >1 
    static uint8 TickSum=0;
#endif

#if EN_USER_TICK_TIMER > 0 
    UserTickTimer();                                    /* û                                                 */
#endif

#if TICK_TIMER_SHARING >1 
    TickSum = (TickSum + 1) % TICK_TIMER_SHARING;
    if (TickSum != 0)
    {
        return;
    }
#endif

#if EN_OS_INT_ENTER > 0 
    OS_INT_ENTER();                                     /* жϿʼ                                             */
#endif
    

#if EN_TIMER_SHARING > 0
    OSTimeTick();                                       /* ϵͳʱӴ                            */
#else
    OSIntSendSignal(TIME_ISR_TASK_ID);
#endif
    
    OSIntExit();                                        /* жϽ                                             */
}

